/*
 * Wizard.java
 *
 * Copyright (C) 2012 Christian Mayer
 *
 * This file is part of CellXGui
 *
 */

/*
 * Wizard.java
 *
 * Created on Feb 14, 2012, 10:18:59 AM
 */
package cellxgui.view.dialogs.wizard;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;

/**
 * From the tutorial here:
 * http://java.sun.com/developer/technicalArticles/GUI/swing/wizard/
 * 
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
abstract public class Wizard extends javax.swing.JDialog implements PropertyChangeListener {

    public static String JUMP_TO = "JumpTo";
    public static int CANCEL_OPTION = 0;
    public static int APPROVE_OPTION = 1;
    private final HashMap<WizardPanel, WizardPanel> panels = new HashMap<WizardPanel, WizardPanel>();
    private int exitValue;
    private WizardPanel currentWizardPanel;

    /** Creates new form Wizard */
    public Wizard(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
        setResizable(false);
    }

    public void proceedToNextPanel() {
        if (currentWizardPanel.validData()) {
            currentWizardPanel.commitData();
            if (currentWizardPanel.isFinalPanel()) {
                exitValue = APPROVE_OPTION;
                dispose();
            } else {
                currentWizardPanel = currentWizardPanel.getNextWizardPanel();
                loadCurrentPanel();
            }
        }
    }

    protected void registerWizardPanel(WizardPanel wp) {
        if (panels.containsKey(wp)) {
            throw new Error("WizardPanel: " + wp + " already contained.");
        }
        panels.put(wp, wp);
        wp.addPropertyChangeListener(this);
    }

    public void setInitialPanel(WizardPanel wp) {
        if (!panels.containsKey(wp)) {
            registerWizardPanel(wp);
        }
        currentWizardPanel = wp;
        loadCurrentPanel();
    }

    private void loadCurrentPanel() {
        currentWizardPanel.beforeShowing();
        centerPanel.removeAll();
        centerPanel.add(currentWizardPanel);

        if (!currentWizardPanel.hasPreviousPanel()) {
            backBtn.setEnabled(false);
        } else {
            backBtn.setEnabled(true);
        }

        if (currentWizardPanel.isFinalPanel()) {
            nextBtn.setText("Finish");
        } else {
            nextBtn.setText("Next>");
        }
        validate();
        repaint();
        currentWizardPanel.afterShowing();
    }

    public int showWizard() {
        this.setVisible(true);
        return exitValue;
    }

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals(JUMP_TO)) {
            if (evt.getNewValue() instanceof WizardPanel) {
                final WizardPanel wp = (WizardPanel) evt.getNewValue();
                if (panels.containsKey(wp)) {
                    currentWizardPanel = wp;
                    loadCurrentPanel();
                }
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        centerPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        nextBtn = new javax.swing.JButton();
        cancelBtn = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        backBtn = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(400, 300));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        centerPanel.setMinimumSize(new java.awt.Dimension(400, 250));
        centerPanel.setPreferredSize(new java.awt.Dimension(400, 250));
        centerPanel.setLayout(new java.awt.BorderLayout());
        getContentPane().add(centerPanel, java.awt.BorderLayout.CENTER);

        jPanel1.setMinimumSize(new java.awt.Dimension(30, 30));
        jPanel1.setPreferredSize(new java.awt.Dimension(400, 50));

        nextBtn.setText("Next >");
        nextBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextBtnActionPerformed(evt);
            }
        });

        cancelBtn.setText("Cancel");
        cancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBtnActionPerformed(evt);
            }
        });

        backBtn.setText("< Back");
        backBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backBtnActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(cancelBtn)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 122, Short.MAX_VALUE)
                .addComponent(backBtn)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(nextBtn)
                .addContainerGap())
            .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(2, 2, 2)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(nextBtn)
                    .addComponent(backBtn)
                    .addComponent(cancelBtn))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void nextBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextBtnActionPerformed
        proceedToNextPanel();
    }//GEN-LAST:event_nextBtnActionPerformed

    private void backBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backBtnActionPerformed
        if (currentWizardPanel.hasPreviousPanel()) {
            currentWizardPanel = currentWizardPanel.getPreviousWizardPanel();
            loadCurrentPanel();
        }
    }//GEN-LAST:event_backBtnActionPerformed

    private void cancelBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnActionPerformed
        exitValue = CANCEL_OPTION;
        dispose();

    }//GEN-LAST:event_cancelBtnActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        exitValue = CANCEL_OPTION;
    }//GEN-LAST:event_formWindowClosing
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton backBtn;
    private javax.swing.JButton cancelBtn;
    private javax.swing.JPanel centerPanel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton nextBtn;
    // End of variables declaration//GEN-END:variables
}
